#ifndef lint
static char const yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif
#ifdef __cplusplus
extern "C" { char *getenv(const char *); }
#else
extern char *getenv();
extern int yylex();
extern int yyparse();
#endif
#define YYPREFIX "yy"
#line 2 "gram.y"
/*
 * Parser for the Aic7xxx SCSI Host adapter sequencer assembler.
 *
 * Copyright (c) 1997 Justin T. Gibbs.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice immediately at the beginning of the file, without modification,
 *    this list of conditions, and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *      $Id: gram.c,v 1.1.1.1 1997/04/11 18:51:35 trost Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sysexits.h>

#include <sys/types.h>
#include <sys/queue.h>

#include "aic7xxx_asm.h"
#include "symbol.h"
#include "sequencer.h"

int yylineno;
char *yyfilename;
static symbol_t *cur_symbol;
static symtype cur_symtype;
static symbol_t *accumulator;
static symbol_ref_t allones;
static symbol_ref_t allzeros;
static symbol_ref_t none;
static symbol_ref_t sindex;
static int instruction_ptr;
static int sram_or_scb_offset;
static patch_t *cur_patch;

static void process_bitmask __P((int mask_type, symbol_t *sym, int mask));
static void initialize_symbol __P((symbol_t *symbol));
static void process_register __P((symbol_t **p_symbol));
static void format_1_instr __P((int opcode, symbol_ref_t *dest,
				expression_t *immed, symbol_ref_t *src,
				int ret));
static void format_2_instr __P((int opcode, symbol_ref_t *dest,
				expression_t *places, symbol_ref_t *src,
				int ret));
static void format_3_instr __P((int opcode, symbol_ref_t *src,
				expression_t *immed, symbol_ref_t *address));
static void test_readable_symbol __P((symbol_t *symbol));
static void test_writable_symbol __P((symbol_t *symbol));
static void type_check __P((symbol_t *symbol, expression_t *expression,
			    int and_op));
static void make_expression __P((expression_t *immed, int value));
static void add_conditional __P((symbol_t *symbol));

#define YYDEBUG 1
#define SRAM_SYMNAME "SRAM_BASE"
#define SCB_SYMNAME "SCB_BASE"
#line 83 "gram.y"
typedef union {
	int		value;
	char		*str;
	symbol_t	*sym;
	symbol_ref_t	sym_ref;
	expression_t	expression;
} YYSTYPE;
#line 115 "y.tab.c"
#define T_REGISTER 257
#define T_CONST 258
#define T_SCB 259
#define T_SRAM 260
#define T_ALIAS 261
#define T_SIZE 262
#define T_ADDRESS 263
#define T_ACCESS_MODE 264
#define T_MODE 265
#define T_BIT 266
#define T_MASK 267
#define T_NUMBER 268
#define T_PATH 269
#define T_EOF 270
#define T_INCLUDE 271
#define T_SHR 272
#define T_SHL 273
#define T_ROR 274
#define T_ROL 275
#define T_MVI 276
#define T_MOV 277
#define T_CLR 278
#define T_JMP 279
#define T_JC 280
#define T_JNC 281
#define T_JE 282
#define T_JNE 283
#define T_JNZ 284
#define T_JZ 285
#define T_CALL 286
#define T_ADD 287
#define T_ADC 288
#define T_INC 289
#define T_DEC 290
#define T_STC 291
#define T_CLC 292
#define T_CMP 293
#define T_XOR 294
#define T_TEST 295
#define T_AND 296
#define T_OR 297
#define T_RET 298
#define T_NOP 299
#define T_ACCUM 300
#define T_ALLONES 301
#define T_ALLZEROS 302
#define T_NONE 303
#define T_SINDEX 304
#define T_A 305
#define T_SYMBOL 306
#define T_NL 307
#define T_IF 308
#define T_ELSE 309
#define T_ENDIF 310
#define UMINUS 311
#define YYERRCODE 256
const short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   15,   15,   24,   16,
   26,   23,   25,   25,   27,   27,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,    6,    6,    6,    6,
    6,    6,    6,    6,    6,   17,   39,   41,   18,   42,
   43,   19,   40,   40,    1,    1,    1,    3,    7,    8,
    8,    4,    5,    5,    9,    9,   20,    2,    2,    2,
    2,    2,    2,   45,   21,   21,   21,   44,   44,   46,
   46,   10,   10,   10,   10,   22,   22,   22,   22,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   11,   11,
   11,   11,   22,   12,   12,   12,   12,   13,   13,   14,
   14,   22,   22,   22,   22,   22,   22,
};
const short yylen[] = {                                         2,
    1,    2,    1,    2,    1,    2,    1,    2,    1,    2,
    1,    2,    1,    2,    1,    2,    4,    4,    0,    3,
    0,    5,    1,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    2,    3,    3,
    2,    1,    1,    1,    1,    1,    3,    3,    3,    3,
    3,    2,    2,    1,    1,    3,    0,    0,    7,    0,
    0,    7,    1,    2,    1,    4,    1,    1,    1,    1,
    1,    1,    0,    2,    0,    1,    2,    1,    3,    3,
    1,    3,    3,    0,    3,    1,    1,    3,    2,    1,
    3,    1,    1,    1,    1,    7,    7,    5,    5,    3,
    7,    3,    4,    6,    6,    4,    2,    2,    1,    1,
    1,    1,    7,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    7,    7,    7,    5,    5,
};
const short yydefred[] = {                                      0,
   19,    0,    0,    0,    0,  110,  109,  112,  111,    0,
    0,    0,  114,  115,  116,  117,   94,   95,    0,    0,
    0,    0,    0,   93,    0,   92,    0,    0,    0,    0,
   84,   86,   87,    0,    0,    0,    0,    1,    3,    5,
    7,    9,   11,   13,   15,    0,    0,   60,   57,    0,
    0,   54,   67,    0,    0,    0,    0,   68,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   76,    0,
    0,    0,    0,   72,    0,    0,    0,  108,  107,   77,
    0,    2,    4,    6,    8,   10,   12,   14,   16,    0,
    0,    0,    0,    0,    0,   20,   56,    0,    0,    0,
    0,    0,   55,   53,   52,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  102,
    0,  100,    0,    0,    0,    0,    0,   85,    0,    0,
    0,    0,    0,    0,  122,   21,    0,   61,   58,   17,
   18,    0,   51,   71,    0,    0,    0,    0,   49,   50,
    0,    0,    0,  106,   74,    0,    0,  103,    0,    0,
    0,    0,    0,    0,   90,    0,    0,   89,    0,    0,
   79,   80,   82,   83,    0,   36,    0,    0,   66,    0,
  127,    0,  126,   98,   99,    0,  120,  121,    0,  119,
  118,    0,    0,    0,    0,   88,    0,    0,    0,    0,
    0,    0,    0,   42,   43,   44,   45,   46,    0,   23,
   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
   35,   63,    0,    0,  105,  104,    0,    0,    0,    0,
    0,   91,    0,    0,   41,   37,   38,    0,    0,   22,
   24,   62,   64,   59,  101,  125,  124,  123,   97,   96,
  113,   39,    0,
};
const short yydgoto[] = {                                      34,
   58,   94,   59,   65,  117,  145,   61,  146,   71,   35,
   36,   37,  192,  189,   38,   39,   40,   41,   42,   43,
   44,   45,  222,   46,  209,  175,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,   99,  223,
  178,   98,  177,  128,   81,  167,
};
const short yysindex[] = {                                     77,
    0, -285,  -86,  -82,  -17,    0,    0,    0,    0,  -34,
 -247, -247,    0,    0,    0,    0,    0,    0, -247, -247,
 -258, -244, -247,    0, -247,    0, -247,   -6,    6,   36,
    0,    0,    0,   77, -247, -247,  -45,    0,    0,    0,
    0,    0,    0,    0,    0, -230, -168,    0,    0, -166,
 -156,    0,    0,   26,  -30,  -30,  -30,    0,   80,   18,
 -182,   26,    0,   83, -182, -177,   84,   84,    0, -177,
   78, -247,   88,    0,   92,   95,  104,    0,    0,    0,
   22,    0,    0,    0,    0,    0,    0,    0,    0,  107,
  108,   -7,   23,  100,   43,    0,    0,  -87,  -87,  115,
  145,  -85,    0,    0,    0,    1,  -31,  -30,  -30,  -30,
  -30,  -45, -247,  -45,  122, -247, -177, -177,  123,    0,
  140,    0,  -31,  -31,  -31,  -33,   22,    0,  -31,  -30,
  -81,  -80,  -79,  -78,    0,    0,  -77,    0,    0,    0,
    0,   93,    0,    0,   18, -177,  135,   48,    0,    0,
  133, -177,  147,    0,    0,  148,  154,    0,  -31, -212,
 -202,   18, -182,   84,    0,   90,  174,    0,   84,    7,
    0,    0,    0,    0,  -92,    0, -230, -230,    0,  157,
    0,  158,    0,    0,    0, -177,    0,    0,  -45,    0,
    0,  -45,  -45, -177,  -88,    0, -177, -177,  -83,  -49,
  -44,  -74,  -73,    0,    0,    0,    0,    0, -106,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -121, -113,    0,    0,  161,  163,  165,  170,
  176,    0,  177,  180,    0,    0,    0,  -27,  -30,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   18,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  181,  181,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   29,    0,    0,    0,    0,    0, -136,
    0,  -28,   46,    0,    0,  181,  -56,  -56,    0,  181,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   -6,  195,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  181,  181,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    5,  181,   16,  -36,    0,    0,
    0,  181,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   25,    0,  -56,    0,    0,    0,    0,  -56,  -56,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  181,    0,    0,    0,    0,
    0,    0,    0,  181,    0,    0,  181,  181,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -99,
};
const short yygindex[] = {                                      0,
    2,  -84,   66,   10,  -50,   24,  130,  -13,  263,    0,
    0,  -41,    0,    0,  222,  223,  225,  226,  235,  247,
  250,  252,  -24,    0,    0,    0,   82,    8,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  114,
    0,    0,    0,    3,    0,    0,
};
#define YYTABLESIZE 461
const short yytable[] = {                                     127,
   93,   48,   73,  242,   48,   57,  126,   48,   57,   57,
   55,  244,   63,   55,   55,   65,   51,  118,  240,  112,
   47,   96,   48,  114,   74,   40,   74,  151,   77,  153,
   65,   72,   75,   60,   76,  131,   48,  132,  109,   69,
   49,  143,   50,  110,  109,  111,   53,   62,   70,  110,
  116,  111,   78,   69,  127,  109,   47,   53,   62,   47,
  110,  126,  111,   70,   79,  133,   55,  134,   70,  187,
  188,   55,   65,   55,   47,   95,   64,   66,  104,  105,
  106,  190,  191,   70,   67,   68,   70,   48,   48,   68,
  110,   56,  111,   80,   56,   56,   13,   14,   15,   97,
   90,   91,  100,   16,  228,  138,  139,  229,  230,  160,
  161,  164,  101,  194,   74,  169,  102,   74,  197,  198,
   69,  193,  152,  107,  108,  155,  113,  116,  166,  168,
  108,  147,  148,  149,  150,  123,  120,  121,  124,   47,
   47,  108,   69,   69,   69,  186,  122,  125,  162,   69,
  129,  130,   55,  170,  199,  200,  137,  201,  135,  202,
  203,   40,   40,   40,   40,  136,   40,   40,  199,  200,
  137,  201,  109,  202,  203,  137,  140,  110,  141,  111,
  154,  158,  142,  159,   95,  179,  171,  172,  173,  174,
  176,  181,   95,  204,  205,  206,  207,  208,  243,  243,
   40,   40,   40,   40,   40,  183,  184,  204,  205,  206,
  207,  208,  185,  195,  196,  225,  226,  232,  236,  245,
  237,  246,  235,  247,   48,   48,   48,   48,  248,   48,
   48,  238,  239,   52,  249,  250,   52,   52,  251,   75,
  252,   73,   48,   48,   48,   48,   48,   48,   48,   48,
   65,   65,   65,   81,  163,   82,   83,   65,   84,   85,
   92,   48,  253,   48,   48,   48,   48,   48,   86,   65,
   53,   54,  165,  144,  103,  103,   47,   47,   47,   47,
   87,   47,   47,   88,   73,   89,   70,   70,   70,   70,
  241,  224,    0,    0,   47,   47,   47,   47,   47,   47,
   47,   47,   70,   69,   69,   69,    0,   55,   55,   55,
   69,    0,    0,   47,   55,   47,   47,   47,   47,   47,
    0,    0,   70,    0,   72,   72,   72,    0,  115,    0,
    0,   72,  119,    1,    2,    3,    4,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,    0,    0,
    0,    0,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,    0,    0,    0,  156,
  157,    0,   30,    0,   31,   32,   33,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  180,    0,
    0,    0,    0,    0,  182,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  227,    0,
    0,    0,    0,    0,    0,    0,  231,    0,    0,  233,
  234,
};
const short yycheck[] = {                                      33,
   46,   38,   59,  125,   41,   40,   40,   44,   40,   40,
   45,  125,   11,   45,   45,   44,   34,   68,  125,   61,
  306,   46,   59,   65,   23,  125,   25,  112,   27,  114,
   59,  276,   23,   10,   25,   43,  123,   45,   38,  298,
  123,   41,   60,   43,   38,   45,  305,  306,   44,   43,
   44,   45,   59,  298,   33,   38,   41,  305,  306,   44,
   43,   40,   45,   59,   59,   43,   38,   45,   44,  282,
  283,   43,   44,   45,   59,  306,   11,   12,   55,   56,
   57,  284,  285,   59,   19,   20,   21,  124,  125,   44,
   43,  126,   45,   58,  126,  126,  279,  280,  281,  268,
   35,   36,  269,  286,  189,   98,   99,  192,  193,  123,
  124,  125,  269,  164,  113,  129,   91,  116,  169,  170,
  298,  163,  113,   44,  124,  116,   44,   44,  126,  127,
  124,  108,  109,  110,  111,   44,   59,   72,   44,  124,
  125,  124,  279,  280,  281,  159,   59,   44,  125,  286,
   44,   44,  124,  130,  261,  262,  263,  264,   59,  266,
  267,  261,  262,  263,  264,  123,  266,  267,  261,  262,
  263,  264,   38,  266,  267,  263,   62,   43,   34,   45,
   59,   59,  268,   44,  306,   93,  268,  268,  268,  268,
  268,   59,  306,  300,  301,  302,  303,  304,  223,  224,
  300,  301,  302,  303,  304,   59,   59,  300,  301,  302,
  303,  304,   59,  124,   41,   59,   59,  306,  268,   59,
  265,   59,  306,   59,  261,  262,  263,  264,   59,  266,
  267,  306,  306,  268,   59,   59,  268,  268,   59,   59,
  268,  298,  279,  280,  281,  282,  283,  284,  285,  286,
  279,  280,  281,   59,  125,   34,   34,  286,   34,   34,
  306,  298,  239,  300,  301,  302,  303,  304,   34,  298,
  305,  306,  306,  305,  306,  306,  261,  262,  263,  264,
   34,  266,  267,   34,   22,   34,  282,  283,  284,  285,
  209,  178,   -1,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  298,  279,  280,  281,   -1,  279,  280,  281,
  286,   -1,   -1,  298,  286,  300,  301,  302,  303,  304,
   -1,   -1,  298,   -1,  279,  280,  281,   -1,   66,   -1,
   -1,  286,   70,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,   -1,   -1,
   -1,   -1,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,   -1,   -1,   -1,  117,
  118,   -1,  306,   -1,  308,  309,  310,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  146,   -1,
   -1,   -1,   -1,   -1,  152,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  186,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  194,   -1,   -1,  197,
  198,
};
#define YYFINAL 34
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 311
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'","'\"'",0,0,0,"'&'",0,"'('","')'",0,"'+'","','","'-'","'.'",0,0,0,0,0,0,0,
0,0,0,0,"':'","';'","'<'",0,"'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_REGISTER","T_CONST","T_SCB",
"T_SRAM","T_ALIAS","T_SIZE","T_ADDRESS","T_ACCESS_MODE","T_MODE","T_BIT",
"T_MASK","T_NUMBER","T_PATH","T_EOF","T_INCLUDE","T_SHR","T_SHL","T_ROR",
"T_ROL","T_MVI","T_MOV","T_CLR","T_JMP","T_JC","T_JNC","T_JE","T_JNE","T_JNZ",
"T_JZ","T_CALL","T_ADD","T_ADC","T_INC","T_DEC","T_STC","T_CLC","T_CMP","T_XOR",
"T_TEST","T_AND","T_OR","T_RET","T_NOP","T_ACCUM","T_ALLONES","T_ALLZEROS",
"T_NONE","T_SINDEX","T_A","T_SYMBOL","T_NL","T_IF","T_ELSE","T_ENDIF","UMINUS",
};
const char * const yyrule[] = {
"$accept : program",
"program : include",
"program : program include",
"program : register",
"program : program register",
"program : constant",
"program : program constant",
"program : scratch_ram",
"program : program scratch_ram",
"program : scb",
"program : program scb",
"program : label",
"program : program label",
"program : conditional",
"program : program conditional",
"program : code",
"program : program code",
"include : T_INCLUDE '<' T_PATH '>'",
"include : T_INCLUDE '\"' T_PATH '\"'",
"$$1 :",
"register : T_REGISTER $$1 reg_definition",
"$$2 :",
"reg_definition : T_SYMBOL '{' $$2 reg_attribute_list '}'",
"reg_attribute_list : reg_attribute",
"reg_attribute_list : reg_attribute_list reg_attribute",
"reg_attribute : reg_address",
"reg_attribute : size",
"reg_attribute : access_mode",
"reg_attribute : bit_defn",
"reg_attribute : mask_defn",
"reg_attribute : alias",
"reg_attribute : accumulator",
"reg_attribute : allones",
"reg_attribute : allzeros",
"reg_attribute : none",
"reg_attribute : sindex",
"reg_address : T_ADDRESS T_NUMBER",
"size : T_SIZE T_NUMBER",
"access_mode : T_ACCESS_MODE T_MODE",
"bit_defn : T_BIT T_SYMBOL T_NUMBER",
"mask_defn : T_MASK T_SYMBOL expression",
"alias : T_ALIAS T_SYMBOL",
"accumulator : T_ACCUM",
"allones : T_ALLONES",
"allzeros : T_ALLZEROS",
"none : T_NONE",
"sindex : T_SINDEX",
"expression : expression '|' expression",
"expression : expression '&' expression",
"expression : expression '+' expression",
"expression : expression '-' expression",
"expression : '(' expression ')'",
"expression : '~' expression",
"expression : '-' expression",
"expression : T_NUMBER",
"expression : T_SYMBOL",
"constant : T_CONST T_SYMBOL T_NUMBER",
"$$3 :",
"$$4 :",
"scratch_ram : T_SRAM '{' $$3 reg_address $$4 scb_or_sram_reg_list '}'",
"$$5 :",
"$$6 :",
"scb : T_SCB '{' $$5 reg_address $$6 scb_or_sram_reg_list '}'",
"scb_or_sram_reg_list : reg_definition",
"scb_or_sram_reg_list : scb_or_sram_reg_list reg_definition",
"reg_symbol : T_SYMBOL",
"reg_symbol : T_SYMBOL '[' T_NUMBER ']'",
"reg_symbol : T_A",
"destination : reg_symbol",
"immediate : expression",
"immediate_or_a : expression",
"immediate_or_a : T_A",
"source : reg_symbol",
"opt_source :",
"opt_source : ',' source",
"ret :",
"ret : T_RET",
"label : T_SYMBOL ':'",
"address : T_SYMBOL",
"address : T_SYMBOL '+' T_NUMBER",
"address : T_SYMBOL '-' T_NUMBER",
"address : '.'",
"address : '.' '+' T_NUMBER",
"address : '.' '-' T_NUMBER",
"$$7 :",
"conditional : T_IF $$7 option_list",
"conditional : T_ELSE",
"conditional : T_ENDIF",
"option_list : '(' option_symbol_list ')'",
"option_list : '!' option_list",
"option_symbol_list : T_SYMBOL",
"option_symbol_list : option_list '|' T_SYMBOL",
"f1_opcode : T_AND",
"f1_opcode : T_XOR",
"f1_opcode : T_ADD",
"f1_opcode : T_ADC",
"code : f1_opcode destination ',' immediate_or_a opt_source ret ';'",
"code : T_OR reg_symbol ',' immediate_or_a opt_source ret ';'",
"code : T_INC destination opt_source ret ';'",
"code : T_DEC destination opt_source ret ';'",
"code : T_CLC ret ';'",
"code : T_CLC T_MVI destination ',' immediate_or_a ret ';'",
"code : T_STC ret ';'",
"code : T_STC destination ret ';'",
"code : T_MOV destination ',' source ret ';'",
"code : T_MVI destination ',' immediate_or_a ret ';'",
"code : T_CLR destination ret ';'",
"code : T_NOP ';'",
"code : T_RET ';'",
"f2_opcode : T_SHL",
"f2_opcode : T_SHR",
"f2_opcode : T_ROL",
"f2_opcode : T_ROR",
"code : f2_opcode destination ',' expression opt_source ret ';'",
"jmp_jc_jnc_call : T_JMP",
"jmp_jc_jnc_call : T_JC",
"jmp_jc_jnc_call : T_JNC",
"jmp_jc_jnc_call : T_CALL",
"jz_jnz : T_JZ",
"jz_jnz : T_JNZ",
"je_jne : T_JE",
"je_jne : T_JNE",
"code : jmp_jc_jnc_call address ';'",
"code : T_OR reg_symbol ',' immediate jmp_jc_jnc_call address ';'",
"code : T_TEST source ',' immediate_or_a jz_jnz address ';'",
"code : T_CMP source ',' immediate_or_a je_jne address ';'",
"code : T_MOV source jmp_jc_jnc_call address ';'",
"code : T_MVI immediate jmp_jc_jnc_call address ';'",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 907 "gram.y"

static void
process_bitmask(mask_type, sym, mask)
	int		mask_type;
	symbol_t	*sym;
	int		mask;
{
	/*
	 * Add the current register to its
	 * symbol list, if it already exists,
	 * warn if we are setting it to a
	 * different value, or in the bit to
	 * the "allowed bits" of this register.
	 */
	if (sym->type == UNINITIALIZED) {
		sym->type = mask_type;
		initialize_symbol(sym);
		if (mask_type == BIT) {
			if (mask == 0) {
				stop("Bitmask with no bits set", EX_DATAERR);
				/* NOTREACHED */
			}
			if ((mask & ~(0x01 << (ffs(mask) - 1))) != 0) {
				stop("Bitmask with more than one bit set",
				     EX_DATAERR);
				/* NOTREACHED */
			}
		}
		sym->info.minfo->mask = mask;
	} else if (sym->type != mask_type) {
		stop("Bit definition mirrors a definition of the same "
		     " name, but a different type", EX_DATAERR);
		/* NOTREACHED */
	} else if (mask != sym->info.minfo->mask) {
		stop("Bitmask redefined with a conflicting value", EX_DATAERR);
		/* NOTREACHED */
	}
	/* Fail if this symbol is already listed */
	if (symlist_search(&(sym->info.minfo->symrefs),
			   cur_symbol->name) != NULL) {
		stop("Bitmask defined multiple times for register", EX_DATAERR);
		/* NOTREACHED */
	}
	symlist_add(&(sym->info.minfo->symrefs), cur_symbol,
		    SYMLIST_INSERT_HEAD);
	cur_symbol->info.rinfo->valid_bitmask |= mask;
	cur_symbol->info.rinfo->typecheck_masks = TRUE;
}

static void
initialize_symbol(symbol)
	symbol_t *symbol;
{
	switch (symbol->type) {
        case UNINITIALIZED:
		stop("Call to initialize_symbol with type field unset",
		     EX_SOFTWARE);
		/* NOTREACHED */
		break;
        case REGISTER:
        case SRAMLOC:
        case SCBLOC:
		symbol->info.rinfo =
		    (struct reg_info *)malloc(sizeof(struct reg_info));
		if (symbol->info.rinfo == NULL) {
			stop("Can't create register info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.rinfo, 0,
		       sizeof(struct reg_info));
		break;
        case ALIAS:
		symbol->info.ainfo =
		    (struct alias_info *)malloc(sizeof(struct alias_info));
		if (symbol->info.ainfo == NULL) {
			stop("Can't create alias info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.ainfo, 0,
		       sizeof(struct alias_info));
		break;
        case MASK:
        case BIT:
		symbol->info.minfo =
		    (struct mask_info *)malloc(sizeof(struct mask_info));
		if (symbol->info.minfo == NULL) {
			stop("Can't create bitmask info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.minfo, 0, sizeof(struct mask_info));
		SLIST_INIT(&(symbol->info.minfo->symrefs));
		break;
        case CONST:
		symbol->info.cinfo =
		    (struct const_info *)malloc(sizeof(struct const_info));
		if (symbol->info.cinfo == NULL) {
			stop("Can't create alias info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.cinfo, 0,
		       sizeof(struct const_info));
		break;
	case LABEL:
		symbol->info.linfo =
		    (struct label_info *)malloc(sizeof(struct label_info));
		if (symbol->info.linfo == NULL) {
			stop("Can't create label info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.linfo, 0,
		       sizeof(struct label_info));
		break;
	case CONDITIONAL:
		symbol->info.condinfo =
		    (struct cond_info *)malloc(sizeof(struct cond_info));
		if (symbol->info.condinfo == NULL) {
			stop("Can't create conditional info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.condinfo, 0,
		       sizeof(struct cond_info));
		break;
	default:
		stop("Call to initialize_symbol with invalid symbol type",
		     EX_SOFTWARE);
		/* NOTREACHED */
		break;
	}
}

static void
process_register(p_symbol)
	symbol_t **p_symbol;
{
	char buf[255];
	symbol_t *symbol = *p_symbol;

	if (symbol->type == UNINITIALIZED) {
		snprintf(buf, sizeof(buf), "Undefined register %s",
			 symbol->name);
		stop(buf, EX_DATAERR);
		/* NOTREACHED */
	} else if (symbol->type == ALIAS) {
		*p_symbol = symbol->info.ainfo->parent;
	} else if ((symbol->type != REGISTER)
		&& (symbol->type != SCBLOC)
		&& (symbol->type != SRAMLOC)) {
		snprintf(buf, sizeof(buf),
			 "Specified symbol %s is not a register",
			 symbol->name);
		stop(buf, EX_DATAERR);
	}
}

static void
format_1_instr(opcode, dest, immed, src, ret)
	int	     opcode;
	symbol_ref_t *dest;
	expression_t *immed;
	symbol_ref_t *src;
	int	     ret;
{
	struct instruction *instr;
	struct ins_format1 *f1_instr;

	if (src->symbol == NULL)
		src = dest;

	/* Test register permissions */
	test_writable_symbol(dest->symbol);
	test_readable_symbol(src->symbol);

	/* Ensure that immediate makes sense for this destination */
	type_check(dest->symbol, immed, opcode);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f1_instr = &instr->format.format1;
	f1_instr->opcode_ret = (opcode << 1) | (ret ? RETURN_BIT : 0);
	f1_instr->destination = dest->symbol->info.rinfo->address
			      + dest->offset;
	f1_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	f1_instr->immediate = immed->value;
	symlist_free(&immed->referenced_syms);
	instruction_ptr++;
}

static void
format_2_instr(opcode, dest, places, src, ret)
	int	     opcode;
	symbol_ref_t *dest;
	expression_t *places;
	symbol_ref_t *src;
	int	     ret;
{
	struct instruction *instr;
	struct ins_format2 *f2_instr;
	u_int8_t shift_control;

	if (src->symbol == NULL)
		src = dest;

	/* Test register permissions */
	test_writable_symbol(dest->symbol);
	test_readable_symbol(src->symbol);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f2_instr = &instr->format.format2;
	f2_instr->opcode_ret = (AIC_OP_ROL << 1) | (ret ? RETURN_BIT : 0);
	f2_instr->destination = dest->symbol->info.rinfo->address
			      + dest->offset;
	f2_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	if (places->value > 8 || places->value <= 0) {
		stop("illegal shift value", EX_DATAERR);
		/* NOTREACHED */
	}
	switch (opcode) {
	case AIC_OP_SHL:
		if (places->value == 8)
			shift_control = 0xf0;
		else
			shift_control = (places->value << 4) | places->value;
		break;
	case AIC_OP_SHR:
		if (places->value == 8) {
			shift_control = 0xf8;
		} else {
			shift_control = (places->value << 4)
				      | (8 - places->value)
				      | 0x08;
		}
		break;
	case AIC_OP_ROL:
		shift_control = places->value & 0x7;
		break;
	case AIC_OP_ROR:
		shift_control = (8 - places->value) | 0x08;
		break;
	default:
		shift_control = 0; /* Quiet Compiler */
		stop("Invalid shift operation specified", EX_SOFTWARE);
		/* NOTREACHED */
		break;
	};
	f2_instr->shift_control = shift_control;
	symlist_free(&places->referenced_syms);
	instruction_ptr++;
}

static void
format_3_instr(opcode, src, immed, address)
	int	     opcode;
	symbol_ref_t *src;
	expression_t *immed;
	symbol_ref_t *address;
{
	struct instruction *instr;
	struct ins_format3 *f3_instr;
	int addr;

	/* Test register permissions */
	test_readable_symbol(src->symbol);

	/* Ensure that immediate makes sense for this source */
	type_check(src->symbol, immed, opcode);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f3_instr = &instr->format.format3;
	if (address->symbol == NULL) {
		/* 'dot' referrence.  Use the current instruction pointer */
		addr = instruction_ptr + address->offset;
	} else if (address->symbol->type == UNINITIALIZED) {
		/* forward reference */
		addr = address->offset;
		instr->patch_label = address->symbol;
	} else
		addr = address->symbol->info.linfo->address + address->offset;
	f3_instr->opcode_addr = (opcode << 1)
			      | ((addr >> 8) & 0x01);
	f3_instr->address = addr & 0xff;
	f3_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	f3_instr->immediate = immed->value;
	symlist_free(&immed->referenced_syms);
	instruction_ptr++;
}

static void
test_readable_symbol(symbol)
	symbol_t *symbol;
{
	if (symbol->info.rinfo->mode == WO) {
		stop("Write Only register specified as source",
		     EX_DATAERR);
		/* NOTREACHED */
	}
}

static void
test_writable_symbol(symbol)
	symbol_t *symbol;
{
	if (symbol->info.rinfo->mode == RO) {
		stop("Read Only register specified as destination",
		     EX_DATAERR);
		/* NOTREACHED */
	}
}

static void
type_check(symbol, expression, opcode)
	symbol_t     *symbol;
	expression_t *expression;
	int	     opcode;
{
	symbol_node_t *node;
	int and_op;
	char buf[255];

	and_op = FALSE;
	if (opcode == AIC_OP_AND || opcode == AIC_OP_JNZ || AIC_OP_JZ)
		and_op = TRUE;
	/*
	 * Make sure that we aren't attempting to write something
	 * that hasn't been defined.  If this is an and operation,
	 * this is a mask, so "undefined" bits are okay.
	 */
	if (and_op == FALSE
	 && (expression->value & ~symbol->info.rinfo->valid_bitmask) != 0) {
		snprintf(buf, sizeof(buf),
			 "Invalid bit(s) 0x%x in immediate written to %s",
			 expression->value & ~symbol->info.rinfo->valid_bitmask,
			 symbol->name);
		stop(buf, EX_DATAERR);
		/* NOTREACHED */
	}

	/*
	 * Now make sure that all of the symbols referenced by the
	 * expression are defined for this register.
	 */
	if(symbol->info.rinfo->typecheck_masks != FALSE) {
		for(node = expression->referenced_syms.slh_first;
		    node != NULL;
		    node = node->links.sle_next) {
			if ((node->symbol->type == MASK
			  || node->symbol->type == BIT)
			 && symlist_search(&node->symbol->info.minfo->symrefs,
					   symbol->name) == NULL) {
				snprintf(buf, sizeof(buf),
					 "Invalid bit or mask %s "
					 "for register %s",
					 node->symbol->name, symbol->name);
				stop(buf, EX_DATAERR);
				/* NOTREACHED */
			}
		}
	}
}

static void
make_expression(immed, value)
	expression_t *immed;
	int	     value;
{
	SLIST_INIT(&immed->referenced_syms);
	immed->value = value & 0xff;
}

static void
add_conditional(symbol)
	symbol_t *symbol;
{
	static int numoptions = 1;

	if (symbol->type == UNINITIALIZED) {
		symbol->type = CONDITIONAL;
		initialize_symbol(symbol);
		symbol->info.condinfo->value = 0x01 << numoptions++;
		symlist_add(&patch_options, symbol, SYMLIST_INSERT_HEAD);
	} else if (symbol->type != CONDITIONAL) {
		stop("Conditional symbol mirrors other symbol",
		     EX_DATAERR);
		/* NOTREACHED */
	}
	cur_patch->options |= symbol->info.condinfo->value;
}

void
yyerror(string)
	const char *string;
{
	stop(string, EX_DATAERR);
}
#line 973 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 17:
#line 185 "gram.y"
{ include_file(yyvsp[-1].str, BRACKETED_INCLUDE); }
break;
case 18:
#line 187 "gram.y"
{ include_file(yyvsp[-1].str, QUOTED_INCLUDE); }
break;
case 19:
#line 191 "gram.y"
{ cur_symtype = REGISTER; }
break;
case 21:
#line 196 "gram.y"
{
			if (yyvsp[-1].sym->type != UNINITIALIZED) {
				stop("Register multiply defined", EX_DATAERR);
				/* NOTREACHED */
			}
			cur_symbol = yyvsp[-1].sym; 
			cur_symbol->type = cur_symtype;
			initialize_symbol(cur_symbol);
		}
break;
case 22:
#line 207 "gram.y"
{                    
			/*
			 * Default to allowing everything in for registers
			 * with no bit or mask definitions.
			 */
			if (cur_symbol->info.rinfo->valid_bitmask == 0)
				cur_symbol->info.rinfo->valid_bitmask = 0xFF;

			if (cur_symbol->info.rinfo->size == 0)
				cur_symbol->info.rinfo->size = 1;

			/*
			 * This might be useful for registers too.
			 */
			if (cur_symbol->type != REGISTER) {
				if (cur_symbol->info.rinfo->address == 0)
					cur_symbol->info.rinfo->address =
					    sram_or_scb_offset;
				sram_or_scb_offset +=
				    cur_symbol->info.rinfo->size;
			}
			cur_symbol = NULL;
		}
break;
case 36:
#line 253 "gram.y"
{
		cur_symbol->info.rinfo->address = yyvsp[0].value;
	}
break;
case 37:
#line 260 "gram.y"
{
		cur_symbol->info.rinfo->size = yyvsp[0].value;
	}
break;
case 38:
#line 267 "gram.y"
{
		cur_symbol->info.rinfo->mode = yyvsp[0].value;
	}
break;
case 39:
#line 274 "gram.y"
{
		process_bitmask(BIT, yyvsp[-1].sym, yyvsp[0].value);
	}
break;
case 40:
#line 281 "gram.y"
{
		process_bitmask(MASK, yyvsp[-1].sym, yyvsp[0].expression.value);
	}
break;
case 41:
#line 288 "gram.y"
{
		if (yyvsp[0].sym->type != UNINITIALIZED) {
			stop("Re-definition of register alias",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[0].sym->type = ALIAS;
		initialize_symbol(yyvsp[0].sym);
		yyvsp[0].sym->info.ainfo->parent = cur_symbol;
	}
break;
case 42:
#line 302 "gram.y"
{
		if (accumulator != NULL) {
			stop("Only one accumulator definition allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		accumulator = cur_symbol;
	}
break;
case 43:
#line 314 "gram.y"
{
		if (allones.symbol != NULL) {
			stop("Only one definition of allones allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		allones.symbol = cur_symbol;
	}
break;
case 44:
#line 326 "gram.y"
{
		if (allzeros.symbol != NULL) {
			stop("Only one definition of allzeros allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		allzeros.symbol = cur_symbol;
	}
break;
case 45:
#line 338 "gram.y"
{
		if (none.symbol != NULL) {
			stop("Only one definition of none allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		none.symbol = cur_symbol;
	}
break;
case 46:
#line 350 "gram.y"
{
		if (sindex.symbol != NULL) {
			stop("Only one definition of sindex allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		sindex.symbol = cur_symbol;
	}
break;
case 47:
#line 362 "gram.y"
{
		 yyval.expression.value = yyvsp[-2].expression.value | yyvsp[0].expression.value;
		 symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 48:
#line 369 "gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value & yyvsp[0].expression.value;
		symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 49:
#line 376 "gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value + yyvsp[0].expression.value;
		symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 50:
#line 383 "gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value - yyvsp[0].expression.value;
		symlist_merge(&(yyval.expression.referenced_syms),
			       &(yyvsp[-2].expression.referenced_syms),
			       &(yyvsp[0].expression.referenced_syms));
	}
break;
case 51:
#line 390 "gram.y"
{
		yyval.expression = yyvsp[-1].expression;
	}
break;
case 52:
#line 394 "gram.y"
{
		yyval.expression = yyvsp[0].expression;
		yyval.expression.value = (~yyval.expression.value) & 0xFF;
	}
break;
case 53:
#line 399 "gram.y"
{
		yyval.expression = yyvsp[0].expression;
		yyval.expression.value = -yyval.expression.value;
	}
break;
case 54:
#line 404 "gram.y"
{
		yyval.expression.value = yyvsp[0].value;
		SLIST_INIT(&yyval.expression.referenced_syms);
	}
break;
case 55:
#line 409 "gram.y"
{
		symbol_t *symbol;

		symbol = yyvsp[0].sym;
		switch (symbol->type) {
		case ALIAS:
			symbol = yyvsp[0].sym->info.ainfo->parent;
		case REGISTER:
		case SCBLOC:
		case SRAMLOC:
			yyval.expression.value = symbol->info.rinfo->address;
			break;
		case MASK:
		case BIT:
			yyval.expression.value = symbol->info.minfo->mask;
			break;
		case CONST:
			yyval.expression.value = symbol->info.cinfo->value;
			break;
		case UNINITIALIZED:
		default:
		{
			char buf[255];

			snprintf(buf, sizeof(buf),
				 "Undefined symbol %s referenced",
				 symbol->name);
			stop(buf, EX_DATAERR);
			/* NOTREACHED */
			break;
		}
		}
		SLIST_INIT(&yyval.expression.referenced_syms);
		symlist_add(&yyval.expression.referenced_syms, symbol, SYMLIST_INSERT_HEAD);
	}
break;
case 56:
#line 448 "gram.y"
{
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Re-definition of constant variable",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = CONST;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.cinfo->value = yyvsp[0].value;
		yyvsp[-1].sym->info.cinfo->define = yyvsp[-2].value;
	}
break;
case 57:
#line 463 "gram.y"
{
			cur_symbol = symtable_get(SRAM_SYMNAME);
			cur_symtype = SRAMLOC;
			if (cur_symbol->type != UNINITIALIZED) {
				stop("Only one SRAM definition allowed",
				     EX_DATAERR);
				/* NOTREACHED */
			}
			cur_symbol->type = SRAMLOC;
			initialize_symbol(cur_symbol);
		}
break;
case 58:
#line 475 "gram.y"
{
			sram_or_scb_offset = cur_symbol->info.rinfo->address;
		}
break;
case 59:
#line 480 "gram.y"
{
			cur_symbol = NULL;
		}
break;
case 60:
#line 487 "gram.y"
{
			cur_symbol = symtable_get(SCB_SYMNAME);
			cur_symtype = SCBLOC;
			if (cur_symbol->type != UNINITIALIZED) {
				stop("Only one SRAM definition allowed",
				     EX_SOFTWARE);
				/* NOTREACHED */
			}
			cur_symbol->type = SCBLOC;
			initialize_symbol(cur_symbol);
		}
break;
case 61:
#line 499 "gram.y"
{
			sram_or_scb_offset = cur_symbol->info.rinfo->address;
		}
break;
case 62:
#line 504 "gram.y"
{
			cur_symbol = NULL;
		}
break;
case 65:
#line 516 "gram.y"
{
		process_register(&yyvsp[0].sym);
		yyval.sym_ref.symbol = yyvsp[0].sym;
		yyval.sym_ref.offset = 0;
	}
break;
case 66:
#line 522 "gram.y"
{
		process_register(&yyvsp[-3].sym);
		if ((yyvsp[-1].value + 1) > yyvsp[-3].sym->info.rinfo->size) {
			stop("Accessing offset beyond range of register",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = yyvsp[-3].sym;
		yyval.sym_ref.offset = yyvsp[-1].value;
	}
break;
case 67:
#line 533 "gram.y"
{
		if (accumulator == NULL) {
			stop("No accumulator has been defined", EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = accumulator;
		yyval.sym_ref.offset = 0;
	}
break;
case 68:
#line 545 "gram.y"
{
		test_writable_symbol(yyvsp[0].sym_ref.symbol);
		yyval.sym_ref = yyvsp[0].sym_ref;
	}
break;
case 69:
#line 553 "gram.y"
{ yyval.expression = yyvsp[0].expression; }
break;
case 70:
#line 558 "gram.y"
{
		yyval.expression = yyvsp[0].expression;
	}
break;
case 71:
#line 562 "gram.y"
{
		SLIST_INIT(&yyval.expression.referenced_syms);
		yyval.expression.value = 0;
	}
break;
case 72:
#line 570 "gram.y"
{
		test_readable_symbol(yyvsp[0].sym_ref.symbol);
		yyval.sym_ref = yyvsp[0].sym_ref;
	}
break;
case 73:
#line 577 "gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = 0;
	}
break;
case 74:
#line 582 "gram.y"
{ yyval.sym_ref = yyvsp[0].sym_ref; }
break;
case 75:
#line 586 "gram.y"
{ yyval.value = 0; }
break;
case 76:
#line 588 "gram.y"
{ yyval.value = 1; }
break;
case 77:
#line 593 "gram.y"
{
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Program label multiply defined", EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = LABEL;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.linfo->address = instruction_ptr;
	}
break;
case 78:
#line 606 "gram.y"
{
		yyval.sym_ref.symbol = yyvsp[0].sym;
		yyval.sym_ref.offset = 0;
	}
break;
case 79:
#line 611 "gram.y"
{
		yyval.sym_ref.symbol = yyvsp[-2].sym;
		yyval.sym_ref.offset = yyvsp[0].value;
	}
break;
case 80:
#line 616 "gram.y"
{
		yyval.sym_ref.symbol = yyvsp[-2].sym;
		yyval.sym_ref.offset = -yyvsp[0].value;
	}
break;
case 81:
#line 621 "gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = 0;
	}
break;
case 82:
#line 626 "gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = yyvsp[0].value;
	}
break;
case 83:
#line 631 "gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = -yyvsp[0].value;
	}
break;
case 84:
#line 639 "gram.y"
{
		if (cur_patch != NULL) {
			stop("Nested .if directive", EX_DATAERR);
			/* NOTREACHED */
		}
		cur_patch = patch_alloc();
		cur_patch->begin = instruction_ptr;
	}
break;
case 86:
#line 652 "gram.y"
{
		patch_t *next_patch;

		if (cur_patch == NULL) {
			stop(".else outsize of .if", EX_DATAERR);
			/* NOTREACHED */
		}
		cur_patch->end = instruction_ptr;
		next_patch = patch_alloc();
		next_patch->options = cur_patch->options;
		next_patch->negative = cur_patch->negative ? FALSE : TRUE;
		cur_patch = next_patch;
		cur_patch->begin = instruction_ptr;
	}
break;
case 87:
#line 670 "gram.y"
{
		if (cur_patch == NULL) {
			stop(".endif outsize of .if", EX_DATAERR);
			/* NOTREACHED */
		}
		cur_patch->end = instruction_ptr;
		cur_patch = NULL;
	}
break;
case 89:
#line 683 "gram.y"
{
		cur_patch->negative = cur_patch->negative ? FALSE : TRUE;
	}
break;
case 90:
#line 690 "gram.y"
{
		add_conditional(yyvsp[0].sym);
	}
break;
case 91:
#line 694 "gram.y"
{
		add_conditional(yyvsp[0].sym);
	}
break;
case 92:
#line 700 "gram.y"
{ yyval.value = AIC_OP_AND; }
break;
case 93:
#line 701 "gram.y"
{ yyval.value = AIC_OP_XOR; }
break;
case 94:
#line 702 "gram.y"
{ yyval.value = AIC_OP_ADD; }
break;
case 95:
#line 703 "gram.y"
{ yyval.value = AIC_OP_ADC; }
break;
case 96:
#line 708 "gram.y"
{
		format_1_instr(yyvsp[-6].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 97:
#line 715 "gram.y"
{
		format_1_instr(AIC_OP_OR, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 98:
#line 722 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 99:
#line 732 "gram.y"
{
		expression_t immed;

		make_expression(&immed, -1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 100:
#line 742 "gram.y"
{
		expression_t immed;

		make_expression(&immed, -1);
		format_1_instr(AIC_OP_ADD, &none, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 101:
#line 749 "gram.y"
{
		format_1_instr(AIC_OP_ADD, &yyvsp[-4].sym_ref, &yyvsp[-2].expression, &allzeros, yyvsp[-1].value);
	}
break;
case 102:
#line 756 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &none, &immed, &allones, yyvsp[-1].value);
	}
break;
case 103:
#line 763 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-2].sym_ref, &immed, &allones, yyvsp[-1].value);
	}
break;
case 104:
#line 773 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &yyvsp[-4].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 105:
#line 783 "gram.y"
{
		format_1_instr(AIC_OP_OR, &yyvsp[-4].sym_ref, &yyvsp[-2].expression, &allzeros, yyvsp[-1].value);
	}
break;
case 106:
#line 790 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &yyvsp[-2].sym_ref, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 107:
#line 800 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &none, &immed, &allzeros, FALSE);
	}
break;
case 108:
#line 810 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &none, &immed, &allzeros, TRUE);
	}
break;
case 109:
#line 828 "gram.y"
{ yyval.value = AIC_OP_SHL; }
break;
case 110:
#line 829 "gram.y"
{ yyval.value = AIC_OP_SHR; }
break;
case 111:
#line 830 "gram.y"
{ yyval.value = AIC_OP_ROL; }
break;
case 112:
#line 831 "gram.y"
{ yyval.value = AIC_OP_ROR; }
break;
case 113:
#line 836 "gram.y"
{
		format_2_instr(yyvsp[-6].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 114:
#line 842 "gram.y"
{ yyval.value = AIC_OP_JMP; }
break;
case 115:
#line 843 "gram.y"
{ yyval.value = AIC_OP_JC; }
break;
case 116:
#line 844 "gram.y"
{ yyval.value = AIC_OP_JNC; }
break;
case 117:
#line 845 "gram.y"
{ yyval.value = AIC_OP_CALL; }
break;
case 118:
#line 849 "gram.y"
{ yyval.value = AIC_OP_JZ; }
break;
case 119:
#line 850 "gram.y"
{ yyval.value = AIC_OP_JNZ; }
break;
case 120:
#line 854 "gram.y"
{ yyval.value = AIC_OP_JE; }
break;
case 121:
#line 855 "gram.y"
{ yyval.value = AIC_OP_JNE; }
break;
case 122:
#line 860 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 0);
		format_3_instr(yyvsp[-2].value, &sindex, &immed, &yyvsp[-1].sym_ref);
	}
break;
case 123:
#line 870 "gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 124:
#line 877 "gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 125:
#line 884 "gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 126:
#line 891 "gram.y"
{
		expression_t immed;

		make_expression(&immed, 0);
		format_3_instr(yyvsp[-2].value, &yyvsp[-3].sym_ref, &immed, &yyvsp[-1].sym_ref);
	}
break;
case 127:
#line 901 "gram.y"
{
		format_3_instr(yyvsp[-2].value, &allzeros, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
#line 1839 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
